package de.intevation.gnv.action;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.apache.log4j.Logger;
import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionForward;
import org.apache.struts.action.ActionMapping;

import de.intevation.gnv.action.sessionmodel.SessionModel;
import de.intevation.gnv.action.sessionmodel.SessionModelFactory;

/**
 * This controller is called to display histograms.<br>
 * An attribute 'histogram' on the request object is activated which inserts an
 * image calling a histogram output of the server.
 *
 * @author <a href="mailto:ingo.weinzierl@intevation.de">Ingo Weinzierl</a>
 */
public class CreateHistogramAction extends DescribeUIAction {

    /**
     * the logger, used to log exceptions and additonaly information
     */
    private static Logger logger = Logger.getLogger(CreateHistogramAction.class);


    /**
     * Constructor
     */
    public CreateHistogramAction() {
        super();
    }


    @Override
    public ActionForward execute(
        ActionMapping       mapping,
        ActionForm          form,
        HttpServletRequest  request,
        HttpServletResponse response)
    throws Exception {
        if (isSessionExhausted(request)) {
            return sessionExhaustedForward(mapping, form, request, response);
        }

        logger.debug("Create histogram.");

        SessionModel sm = SessionModelFactory.getInstance().getSessionModel(
            request);
        sm.setDiagrammOptions(null);
        request.setAttribute("histogram", true);

        return super.execute(mapping, form, request, response);
    }
}
// vim:set ts=4 sw=4 si et sta sts=4 fenc=utf-8 :
